unit Prman_u;

{**************************************************************************

  Delphi-Project-Starter

  Opens Delphi a Delphi project and it's according Component Library

  Author: Hannes Danzl (e9026733@stud3.tuwien.ac.at)

  FREEWARE

  If you change it, please send me a copy!!

************************************************************************** }

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Buttons, ExtCtrls, IniFiles, Menus, DB,
  DBTables, DBCtrls, Mask, regi1632, DBRecNum;

type
  EIniList = class(exception);

  TForm1 = class(TForm)
    Panel1: TPanel;
    BitBtn1: TBitBtn;
    BitBtn3: TBitBtn;
    Label1: TLabel;
    Label2: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    MainMenu1: TMainMenu;
    Konfiguration1: TMenuItem;
    DelphiPfad1: TMenuItem;
    DelphiIniDatei1: TMenuItem;
    OpenDialog1: TOpenDialog;
    Button1: TButton;
    Button3: TButton;
    Table1: TTable;
    DataSource1: TDataSource;
    thename: TDBEdit;
    dcl: TDBEdit;
    dclpfad: TDBEdit;
    dpr: TDBEdit;
    DBNavigator1: TDBNavigator;
    DBMemo1: TDBMemo;
    Label3: TLabel;
    Version: TDBRadioGroup;
    Delphi101: TMenuItem;
    Delphi102: TMenuItem;
    Path1: TMenuItem;
    Import1: TMenuItem;
    Version101: TMenuItem;
    Table2: TTable;
    OpenDialog2: TOpenDialog;
    GetCurrentConfig1: TMenuItem;
    CurrentDelphi10Config1: TMenuItem;
    CurrentDelphi20Config1: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure DelphiPfad1Click(Sender: TObject);
    procedure DelphiIniDatei1Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure Path1Click(Sender: TObject);
    procedure Version101Click(Sender: TObject);
    procedure CurrentDelphi10Config1Click(Sender: TObject);
    procedure CurrentDelphi20Config1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private-Deklarationen }
    DelphiExe:String;
    DelphiINI:String;
    Delphi32Exe:String;
    procedure OpenDelphi1;
    procedure OpenDelphi2;
    function FindRecordNumber: Longint;
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

uses DBiProcs, DBiTypes;

procedure TForm1.FormCreate(Sender: TObject);
var TheIniFile:TIniFile;
    aregistry:TRegistry1632;
    text:string;
begin
  { get configuration }
  TheIniFile:=TIniFile.Create(extractfilepath(paramstr(0))+'prmanag.ini');
  delphiexe:=theInifile.readstring('Konfiguration','DelphiEXE','');
  delphiINI:=theInifile.readstring('Konfiguration','DelphiINI','');
  delphi32exe:=theInifile.readstring('Konfiguration','Delphi32EXE','');
  { open table and move to last saved position }
  table1.tablename:=extractfilepath(paramstr(0))+'prmanag.db';
  table1.active:=true;
  table1.first;
  table1.moveby(theIniFile.readinteger('Settings','LastDataRecord',1)-1);
  TheIniFile.free;
end;

procedure TForm1.DelphiPfad1Click(Sender: TObject);
var TheIniFile:TIniFile;
begin
  { change Delphi 1.0 filename }
  if delphiEXE<>'' then
    opendialog1.filename:=delphiexe;
  opendialog1.filterindex:=1;
  if opendialog1.execute then
  begin
    delphiexe:=opendialog1.fileName;
    TheIniFile:=TIniFile.Create(extractfilepath(paramstr(0))+'prmanag.ini');
    theInifile.writestring('Konfiguration','DelphiEXE',delphiexe);
    TheIniFile.Free;
  end;
end;

procedure TForm1.DelphiIniDatei1Click(Sender: TObject);
var TheIniFile:TIniFile;
begin
  { change Delphi 1.0 ini-filename }
  if delphiINI<>'' then
    opendialog1.filename:=delphiINI;
  opendialog1.filterindex:=2;
  if opendialog1.execute then
  begin
    delphiINI:=opendialog1.fileName;
    TheIniFile:=TIniFile.Create(extractfilepath(paramstr(0))+'prmanag.ini');
    theInifile.writestring('Konfiguration','DelphiINI',delphiINI);
    TheIniFile.Free;
  end;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  { get project filename }
  opendialog1.filterindex:=4;
  opendialog1.fileName:='';
  if opendialog1.execute then
  begin
    table1.edit;
    dpr.text:=opendialog1.fileName;
    table1.post;
  end;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  { get library filename }
  opendialog1.filterindex:=3;
  opendialog1.fileName:='';
  if opendialog1.execute then
  begin
    table1.edit;
    dcl.text:=opendialog1.fileName;
    table1.post;
  end;
end;

procedure TForm1.Opendelphi2;
var pdelphiexe:array[0..256] of char;
    aregistry:TRegistry1632;
begin
  { write settings to registry and start delphi 2.0 }
  if fileexists(delphi32exe) then
  begin
    aregistry:=Tregistry1632.Create;

    aregistry.WriteUserString('Software\Borland\Delphi\2.0\Session\','Project', dpr.text);
    aregistry.WriteUserString('Software\Borland\Delphi\2.0\Library\','ComponentLibrary',dcl.text);
    aregistry.WriteUserString('Software\Borland\Delphi\2.0\Library\','SearchPath', dclpfad.text);

    if aregistry.runningwin31 then
      messagedlg('Delphi 2.0 cannot be started in Windows 3.x',mterror,[mbok],0)
    else
    begin
      strpcopy(pdelphiexe,delphi32exe);
      winexec(pdelphiexe,sw_show);
    end;
    aregistry.free;
  end
  else
    messagedlg('Please check the settings for correct filenames!',mterror,[mbok],0);
end;

procedure TForm1.OpenDelphi1;
var delphiIniFile:TIniFile;
    pdelphiexe:array[0..256] of char;
begin
  { write settings to ini-file and start delphi 1.0 }
  if fileexists(delphiINI) and fileexists(delphiexe) then
  begin
    delphiIniFile:=TIniFile.Create(delphiIni);
    delphiIniFile.WriteString('Library','SearchPath',dclpfad.text);
    delphiIniFile.WriteString('Library','ComponentLibrary',dcl.text);
    delphiIniFile.WriteString('Session','Project',dpr.text);
    strpcopy(pdelphiexe,delphiexe);
    winexec(pdelphiexe,sw_show);
    delphiIniFile.Free;
  end
  else
    messagedlg('Please check the settings for correct filenames!',mterror,[mbok],0);
end;

procedure TForm1.BitBtn1Click(Sender: TObject);
begin
  { starts delphi 1.0 or 2.0 }
  if version.value='Delphi 1.0' then
    opendelphi1
  else
  if version.value='Delphi 2.0' then
    opendelphi2;
end;

procedure TForm1.Path1Click(Sender: TObject);
var TheIniFile:TIniFile;
begin
  { set Delphi 2.0 filename }
  if delphi32EXE<>'' then
    opendialog1.filename:=delphi32exe;
  opendialog1.filterindex:=1;
  if opendialog1.execute then
  begin
    delphi32exe:=opendialog1.fileName;
    TheIniFile:=TIniFile.Create(extractfilepath(paramstr(0))+'prmanag.ini');
    theInifile.writestring('Konfiguration','Delphi32EXE',delphi32exe);
    TheIniFile.Free;
  end;
end;

procedure TForm1.Version101Click(Sender: TObject);
begin
  { import Data from Version 1.0 since the database was changed! }
  if opendialog2.execute then
    if fileexists(opendialog2.filename) then
    begin
      table2.tablename:=opendialog2.filename;
      table2.active:=true;
      table2.first;
      while not table2.eof do
      begin
        table1.appendrecord([table2.fields[0].asstring,nil,table2.fields[2].asstring,
          table2.fields[3].asstring,table2.fields[4].asstring, 'Delphi 1.0']);
        table1.edit;
        tmemofield(table1.fields[1]).assign(tmemofield(table2.fields[1]));
        table1.post;
        table2.next;
      end;
      table2.close;
      table1.first;
    end;
end;

procedure TForm1.CurrentDelphi10Config1Click(Sender: TObject);
var delphiIniFile:TIniFile;
begin
  { get current delphi 1.0 configuration }
  if fileexists(delphiINI) then
  begin
    delphiIniFile:=TIniFile.Create(delphiIni);
    table1.Append;
    theName.Text:='Current Delphi 1.0 Config';
    dclpfad.text:=delphiIniFile.ReadString('Library','SearchPath','');
    dcl.text:=delphiIniFile.ReadString('Library','ComponentLibrary','');
    dpr.text:=delphiIniFile.ReadString('Session','Project','');
    dbMemo1.lines.add('Automatically added on '+datetostr(sysutils.date) + ' ' + timetostr(sysutils.time));
    Version.Value:='Delphi 1.0';
    table1.post;
    table1.last;
    delphiIniFile.Free;
  end
  else
    messagedlg('Please check the settings for correct filenames!',mterror,[mbok],0);
end;

procedure TForm1.CurrentDelphi20Config1Click(Sender: TObject);
var delphiIniFile:TIniFile;
    result:longint;
    atext:array[0..256] of char;
    alength:LongInt;
    aregistry:TRegistry1632;
begin
  { get current delphi 2.0 configuration }
  table1.Append;

  theName.Text:='Current Delphi 2.0 Config';
  aregistry:=TRegistry1632.Create;

  dpr.text:=aregistry.ReadUserString('Software\Borland\Delphi\2.0\Session\','Project');
  dcl.text:=aregistry.ReadUserString('Software\Borland\Delphi\2.0\Library\','ComponentLibrary');
  dclpfad.text:=aregistry.ReadUserString('Software\Borland\Delphi\2.0\Library\','SearchPath');
  aregistry.free;

  dbMemo1.lines.add('Automatically added on '+datetostr(sysutils.date) + ' ' + timetostr(sysutils.time));
  Version.Value:='Delphi 2.0';
  table1.post;
  table1.last;
end;

function TForm1.FindRecordNumber: Longint;
var
  cP: CurProps;
  rP: RECProps;
  FDataLink:TDataLink;
begin
  { method to find record number }
  Result := 0;

  FDataLink := TFieldDataLink.Create;
  FDataLink.DataSource := DataSource1;

  with FDataLink.DataSource.Dataset do
  begin
    {we need to make this call to grab the cursor's iSeqNums}
    Check(DBiGetCursorProps(Handle,cP));
    {synchronize the BDE cursor with the dataset's cursor}
    UpdateCursorPos;
    {fill rP with the current record's properties}
    Check(DBiGetRecord(Handle,DBiNOLOCK,nil,@rP));
    {what kind of dataset are we looking at?}
    case cP.iSeqNums of
      0: Result := rP.iPhyRecNum; {dBase}
      1: Result := rP.iSeqNum;    {Paradox}
    end;
  end;

  FDataLink.Free;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
var theIniFile:TIniFile;
begin
  { write the current RecordNumber to Ini-File } 
  TheIniFile:=TIniFile.Create(extractfilepath(paramstr(0))+'prmanag.ini');
  theInifile.writeinteger('Settings','LastDataRecord',findrecordNumber);
  TheIniFile.Free;
end;

end.
